/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.MotivoReimpresion;
import com.rjconsultores.ventaboletos.service.MotivoReimpresionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import java.util.Calendar;
import java.util.List;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("editarMotivoReimpresionController")
@Scope("prototype")
public class EditarMotivoReimpresionController extends MyGenericForwardComposer {

    @Autowired
    private MotivoReimpresionService motivoReimpresionService;
    private MotivoReimpresion motivoReimpresion;
    private MyListbox motivoReimpresionList;
    private static Logger log = Logger.getLogger(EditarMotivoReimpresionController.class);
    private Textbox txtNome;
    private Button btnApagar;
    private Button btnSalvar;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        motivoReimpresion = (MotivoReimpresion) Executions.getCurrent().getArg().get("motivoReimpresion");
        motivoReimpresionList = (MyListbox) Executions.getCurrent().getArg().get("motivoReimpresionList");

        if (motivoReimpresion.getMotivoreimpresionId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            if (motivoReimpresion.getMotivoreimpresionId() < 2) {
                btnApagar.setVisible(Boolean.FALSE);
                btnSalvar.setVisible(Boolean.FALSE);
                txtNome.setDisabled(Boolean.TRUE);

                Messagebox.show(
                        Labels.getLabel("MSG.noEditabled"),
                        Labels.getLabel("editarMotivoReimpresionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            }
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();

        try {
            motivoReimpresion.setActivo(true);
            motivoReimpresion.setFecmodif(Calendar.getInstance().getTime());
            motivoReimpresion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            if (motivoReimpresion.getMotivoreimpresionId() == null) {
                List<MotivoReimpresion> lsMotivoReimpresion =
                        motivoReimpresionService.buscar(motivoReimpresion.getDescmotivo());

                if (lsMotivoReimpresion.isEmpty()) {
                    motivoReimpresionService.suscribir(motivoReimpresion);
                    motivoReimpresionList.addItem(motivoReimpresion);

                    Messagebox.show(
                            Labels.getLabel("editarMotivoReimpresionController.MSG.suscribirOK"),
                            Labels.getLabel("editarMotivoReimpresionController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);
                } else {
                    Messagebox.show(
                            Labels.getLabel("MSG.Registro.Existe"),
                            Labels.getLabel("editarMotivoReimpresionController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                }
            } else {
                motivoReimpresionService.actualizacion(motivoReimpresion);
                motivoReimpresionList.updateItem(motivoReimpresion);

                Messagebox.show(
                        Labels.getLabel("editarMotivoReimpresionController.MSG.suscribirOK"),
                        Labels.getLabel("editarMotivoReimpresionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            }

            closeWindow();
        } catch (Exception ex) {
            log.error("editarMotivoReimpresionController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarMotivoReimpresionController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarMotivoReimpresionController.MSG.borrarPergunta"),
                    Labels.getLabel("editarMotivoReimpresionController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                motivoReimpresionService.borrar(motivoReimpresion);

                Messagebox.show(
                        Labels.getLabel("editarMotivoReimpresionController.MSG.borrarOK"),
                        Labels.getLabel("editarMotivoReimpresionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                motivoReimpresionList.removeItem(motivoReimpresion);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public MotivoReimpresion getMotivoReimpresion() {
        return motivoReimpresion;
    }

    public void setMotivoReimpresion(MotivoReimpresion motivoReimpresion) {
        this.motivoReimpresion = motivoReimpresion;
    }

    public MyListbox getMotivoReimpresionList() {
        return motivoReimpresionList;
    }

    public void setMotivoReimpresionList(MyListbox motivoReimpresionList) {
        this.motivoReimpresionList = motivoReimpresionList;
    }

    public MotivoReimpresionService getMotivoReimpresionService() {
        return motivoReimpresionService;
    }

    public void setMotivoReimpresionService(MotivoReimpresionService motivoReimpresionService) {
        this.motivoReimpresionService = motivoReimpresionService;
    }
}
